; Version 1.2.4

Global $g_metaIniFile = @ScriptDir & "\meta.ini"
Global $g_eacFullTitle = ""
Global $g_arrMetaData
Global $lstTokens, $btnAdd, $btnUpdate, $btnDelete, $txtToken, $txtValue, $btnOK
Global $arrDefault
Global $intAdding = -1
Global $intSelectedItem = 0
Global $g_arrItem[1]
$g_arrItem[0] = 0

; Create the GUI
Func fDiagCreate()
	Opt("GUIOnEventMode", 1)

	GUICreate("Additional Meta Data", 320, 260, -1, -1, $WS_POPUP + $WS_CAPTION + $WS_SYSMENU, $WS_EX_TOOLWINDOW, $g_eacHandle)
	GUISetOnEvent($GUI_EVENT_CLOSE, "fDiagClose")

	$lstTokens = GuiCtrlCreateListView("Token|Value", 5, 5, 310, 150, $LVS_SHOWSELALWAYS + $LVS_NOSORTHEADER + $LVS_SINGLESEL)
	_GUICtrlListViewSetColumnWidth($lstTokens, 0, 120)
	_GUICtrlListViewSetColumnWidth($lstTokens, 1, $LVSCW_AUTOSIZE_USEHEADER)

	fReadMetaDataDefaults()
	
	$btnAdd = GuiCtrlCreateButton ("Add",5,160,60)
	GUICtrlSetOnEvent($btnAdd, "fDiagAddButton")

	$btnUpdate = GuiCtrlCreateButton ("Update",70,160,60)
	GUICtrlSetOnEvent($btnUpdate, "fDiagUpdateButton")

	$btnDelete = GuiCtrlCreateButton ("Delete",135,160,60)
	GUICtrlSetOnEvent($btnDelete, "fDiagDeleteButton")

	GuiCtrlCreateLabel("Token", 5, 190)
	GuiCtrlCreateLabel("Value", 130, 190)

	$txtToken = GuiCtrlCreateInput("",5,205,120)
	GUICtrlSetOnEvent($txtToken, "fDiagInputBlur")

	$txtValue = GuiCtrlCreateInput("",130,205,185)
	GUICtrlSetOnEvent($txtValue, "fDiagInputBlur")

	$btnOK = GuiCtrlCreateButton ("Close",255,230,60)
	GUICtrlSetOnEvent($btnOK, "fDiagOKButton")

	fDiagDisableEdit()
	fDiagDisableInput()
EndFunc

; Make GUI visible
Func fDiagOpen()
	GuiSetState(@SW_SHOW)
EndFunc

; Tidy up and hide GUI
Func fDiagClose()
	If $intAdding > -1 Then
		fDiagClearAdding()
		fDiagSetText("", "")
		fDiagDisableInput()
	EndIf
	GuiSetState(@SW_HIDE)
EndFunc

;Enable GUI
Func fDiagEnable()
	GuiSetState(@SW_ENABLE)
EndFunc

;Disable GUI
Func fDiagDisable()
	GuiSetState(@SW_DISABLE)
EndFunc

; User has clicked the Add button
Func fDiagAddButton()
	Local $strAddToken, $strAddValue
;	If fDiagIsValidValues(GUICtrlRead($txtToken), GUICtrlRead($txtValue)) Then
;		$strAddToken = GUICtrlRead($txtToken)
;		$strAddValue = GUICtrlRead($txtValue)
;	Else
		$strAddToken = "<token>"
		$strAddValue = "<value>"
;	EndIf	
	fDiagCreateItem($strAddToken, $strAddValue)
	$intAdding = $g_arrItem[0]
	$intSelectedItem = $g_arrItem[0]
	fDiagDisableEdit()
	fDiagEnableInput()
	fDiagSetText($strAddToken, $strAddValue)
	fDiagDisableAdd()
	GUICtrlSetState($g_arrItem[$intSelectedItem], $GUI_FOCUS)
	GUICtrlSetState($txtToken, $GUI_FOCUS)
EndFunc

; User has clicked the Update button
Func fDiagUpdateButton()
	GUICtrlSetData($g_arrItem[$intSelectedItem], _
		GUICtrlRead($txtToken) & "|" & StringReplace(GUICtrlRead($txtValue), "|", ""))
	fDiagEnableAdd()
	fDiagEnableEdit()
	GUICtrlSetState($g_arrItem[$intSelectedItem], $GUI_FOCUS)
	;fWriteMetaDataToIni()
EndFunc

; User has clicked the Delete button
Func fDiagDeleteButton()
	fDiagRemoveItem($intSelectedItem)
	fDiagDisableEdit()
	fDiagSetText("", "")
	fDiagDisableInput()
	;fWriteMetaDataToIni()
EndFunc

; User has exited a text box
Func fDiagInputBlur()
	fDiagCheckValues()
EndFunc

; User has selected a list item
Func fDiagListItem()
	Local $i
	For $i = 1 to $g_arrItem[0]
		If @GUI_CTRLID = $g_arrItem[$i] Then
			fDiagSetTextFromItem($i)
			$intSelectedItem = $i
			If $i <> $intAdding Then
				fDiagEnableEdit()
				If $intAdding > -1 Then fDiagClearAdding()
			EndIf
			ExitLoop
		EndIf
	Next
EndFunc

; User has clicked the OK button
Func fDiagOKButton()
	;fWriteMetaDataToIni()
	fDiagClose()
EndFunc

; (Re-)initialise the GUI
Func fDiagReinitialise()
	If $intAdding > -1 Then fDiagClearAdding()
	If $g_arrItem[0] > 0 Then fDiagClearList()
	fLoadDefaults()
	fDiagDisableEdit()
	fDiagSetText("", "")
	fDiagDisableInput()
;	fWriteMetaDataToIni()
	fDiagEnable()
EndFunc

; Validate text boxes and set Update button state accordingly
Func fDiagCheckValues()
	If fDiagIsValidValues(GUICtrlRead($txtToken), GUICtrlRead($txtValue)) Then
		GUICtrlSetState($btnUpdate, $GUI_ENABLE)
	Else
		GUICtrlSetState($btnUpdate, $GUI_DISABLE)
	EndIf
EndFunc

; Are the token name and values valid?
Func fDiagIsValidValues($strToken, $strValue)
	Return StringRegExp($strToken, "\A_*[a-zA-Z\d]+(\[\d{1,2}\])*\z")
EndFunc

; Load defaults from array into list
Func fLoadDefaults()
	For $i = 1 To $arrDefault[0][0]
		If fDiagIsValidValues($arrDefault[$i][0], $arrDefault[$i][1]) Then
			fDiagCreateItem($arrDefault[$i][0], $arrDefault[$i][1])
		EndIf
	Next
EndFunc

; Remove all list items
Func fDiagClearList()
	Local $i
	For $i = 1 to $g_arrItem[0]
		fDiagRemoveItem($i)
	Next
	ReDim $g_arrItem[1]
	$g_arrItem[0] = 0
EndFunc

; Create a new list item
Func fDiagCreateItem($strToken, $strValue)
	$g_arrItem[0] += 1
	ReDim $g_arrItem[$g_arrItem[0] + 1]
	$g_arrItem[$g_arrItem[0]] = GuiCtrlCreateListViewItem($strToken & "|" & StringReplace($strValue, "|", ""), $lstTokens)
	GUICtrlSetOnEvent($g_arrItem[$g_arrItem[0]], "fDiagListItem")
EndFunc

; Remove a list item
Func fDiagRemoveItem($intIndex)
	GUICtrlDelete($g_arrItem[$intIndex])
	$g_arrItem[$intIndex] = 0
	$intSelectedItem = -1
EndFunc

; No longer adding, clear ghost item
Func fDiagClearAdding()
	fDiagRemoveItem($intAdding)
	fDiagEnableAdd()
EndFunc

; Set text box values
Func fDiagSetText($strToken, $strValue)
	GUICtrlSetData($txtToken, $strToken)
	GUICtrlSetData($txtValue, $strValue)
	fDiagCheckValues()
EndFunc

; Set text box values from list item
Func fDiagSetTextFromItem($intIndex)
	Local $arrColumn = StringSplit(GUICtrlRead($g_arrItem[$intIndex]), "|")
	GUICtrlSetData($txtToken, $arrColumn[1])
	GUICtrlSetData($txtValue, StringReplace($arrColumn[2], "", "|"))
	fDiagCheckValues()
EndFunc

; Enable Add state
Func fDiagEnableAdd()
	GUICtrlSetState($btnAdd, $GUI_ENABLE)
	$intAdding = -1
EndFunc

; Disable Add state
Func fDiagDisableAdd()
	GUICtrlSetState($btnAdd, $GUI_DISABLE)
EndFunc

; Enable Edit state
Func fDiagEnableEdit()
	GUICtrlSetState($btnUpdate, $GUI_ENABLE)
	GUICtrlSetState($btnDelete, $GUI_ENABLE)
	fDiagEnableInput()
EndFunc

; Disable Edit state
Func fDiagDisableEdit()
	GUICtrlSetState($btnUpdate, $GUI_DISABLE)
	GUICtrlSetState($btnDelete, $GUI_DISABLE)
EndFunc

; Enable Input state
Func fDiagEnableInput()
	GUICtrlSetState($txtToken, $GUI_ENABLE)
	GUICtrlSetState($txtValue, $GUI_ENABLE)
EndFunc

; Disable Input state
Func fDiagDisableInput()
	GUICtrlSetState($txtToken, $GUI_DISABLE)
	GUICtrlSetState($txtValue, $GUI_DISABLE)
EndFunc

; Taken from AutoIt's GuiListView.au3
Func _GUICtrlListViewSetColumnWidth($h_listview, $i_col, $i_width)
	If IsHWnd($h_listview) Then
		Return _SendMessage ($h_listview, $LVM_SETCOLUMNWIDTH, $i_col, $i_width)
	Else
		Return GUICtrlSendMsg($h_listview, $LVM_SETCOLUMNWIDTH, $i_col, $i_width)
	EndIf
EndFunc

; Read the additional meta data defaults from the ini, and create the ini if they don't exist
Func fReadMetaDataDefaults()
	; Read default token/value pairs from metadata.ini
	$arrDefault = IniReadSection($g_iniFile, "DefaultMetaData")
	
	; If ini could not be read set array maulally and write to (new) ini file
	If @error Then
		fCreateMetaDataDefaults()
	EndIf
EndFunc

; Create metadata.ini, setting defaults
Func fCreateMetaDataDefaults()
	Dim $arrDefault[4][2]
	$arrDefault[0][0] = 3
	$arrDefault[1][0] = "discnumber"
	$arrDefault[1][1] = "1"
	$arrDefault[2][0] = "totaldiscs"
	$arrDefault[2][1] = "1"
	$arrDefault[3][0] = "discname"
	$arrDefault[3][1] = ""
	FileWrite($g_iniFile, @CRLF)
	IniWriteSection($g_iniFile, "DefaultMetaData", $arrDefault)
EndFunc

; Update ini file with the current token/value pairs
Func fWriteMetaDataToIni()
	Local $strItem, $arrColumn
	IniDelete($g_metaIniFile, "Current")
	For $i = 1 to $g_arrItem[0]
		$strItem = GUICtrlRead($g_arrItem[$i])
		If $strItem <> "0" And $i <> $intAdding Then
			$arrColumn = StringSplit($strItem, "|")
			IniWrite($g_metaIniFile, "Current", $arrColumn[1], StringReplace($arrColumn[2], "", "|"))
		EndIf
	Next
EndFunc

; Load current token/value pairs from ini file
Func fLoadMetaDataFromIni()
	$g_arrMetaData = IniReadSection($g_metaIniFile, "Current")
EndFunc

; Convert arrItem array into ini format
Func fConvertMetaDataToIni()
	Local $strItem, $arrColumn, $arrReturn[1][2]
	$arrReturn[0][0] = 0
	For $i = 1 to $g_arrItem[0]
		$strItem = GUICtrlRead($g_arrItem[$i])
		If $strItem <> "0" And $i <> $intAdding Then
			$arrColumn = StringSplit($strItem, "|")
			ReDim $arrReturn[UBound($arrReturn, 1) + 1][2]
			$arrReturn[0][0] = UBound($arrReturn, 1)
			$arrReturn[UBound($arrReturn, 1) - 1][0] = $arrColumn[1]
			$arrReturn[UBound($arrReturn, 1) - 1][1] = StringReplace($arrColumn[2], "", "|")
		EndIf
	Next
	Return $arrReturn
EndFunc

; Replace all current tokens with their values
Func fReplaceAdditionalMetaData($strText, $bytTrackNumber)
	Local $i, $arrMatch, $strToken, $strValue
	If IsArray($g_arrMetaData) Then
		For $i = 1 To $g_arrMetaData[0][0]
			$arrMatch = StringRegExp($g_arrMetaData[$i][0], "\A_*([a-zA-Z\d]+)\[(\d{1,2})\]\z", 1)
			If @error == 0 Then
				If Number($arrMatch[1]) == Number($bytTrackNumber) Then
					$strToken = $arrMatch[0]
				EndIf
			Else
				$strToken = $g_arrMetaData[$i][0]
			EndIf
			$strText = fStringReplaceForDOS($strText, "@" & $strToken & "@", StringReplace($g_arrMetaData[$i][1], """", "'"))
			If StringIsInt($g_arrMetaData[$i][1]) Then
				$strValue = StringFormat("%02d", $g_arrMetaData[$i][1])
			Else
				$strValue = fSubstIllegalChars($g_arrMetaData[$i][1])
			EndIf
			$strText = fStringReplaceForDOS($strText, "$" & $strToken & "$", $strValue)
		Next
	EndIf
	Return $strText
EndFunc

; Add additional meta data to a cuesheet
Func fAddAdditionalMetaDataToCuesheet($strCuesheet)
	Local $i, $arrMatch, $bytTrack
	If IsArray($g_arrMetaData) Then
		For $i = $g_arrMetaData[0][0] To 1 Step -1
			If StringLen($g_arrMetaData[$i][1]) = 0 Or StringLeft($g_arrMetaData[$i][0], 1) = "_" Then ContinueLoop
			$arrMatch = StringRegExp($g_arrMetaData[$i][0], "\A([a-zA-Z\d]+)\[(\d{1,2})\]\z", 1)
			If @error == 0 Then
				$bytTrack = StringFormat("%02d", $arrMatch[1])
				$strCuesheet = StringRegExpReplace($strCuesheet, _
					"TRACK " & $bytTrack & " AUDIO", _
					"TRACK " & $bytTrack & " AUDIO" & @CRLF _
					& "    " _
					& "REM " _
					& fQuote(StringUpper($arrMatch[0])) _
					& " " _
					& fQuote(StringReplace($g_arrMetaData[$i][1], "\", "\\")))
			Else
				$strCuesheet = "REM " _
					& fQuote(StringUpper($g_arrMetaData[$i][0])) _
					& " " _
					& fQuote($g_arrMetaData[$i][1]) _
					& @CRLF _
					& $strCuesheet
			EndIf
		Next
	EndIf
	Return $strCuesheet
EndFunc

; Surround a value in quotes if it contains spaces
Func fQuote($strText)
	$strText = StringReplace($strText, """", "'")
	If StringInstr($strText, " ") > 0 Then
		Return """" & $strText & """"
	Else
		Return $strText
	EndIf
EndFunc

; Loads a cuesheet, adds additional meta data and resaves it
Func fLoadAndResaveCuesheet($strFilename)
	Local $strCuesheet = FileRead($strFilename)
	If @error = 1 Then
		fDebugPrint($strFilename & " not found. Cannot add metadata.")
	Else
		Local $objCuesheet = FileOpen($strFilename, 2)
		FileWrite($objCuesheet, fAddAdditionalMetaDataToCuesheet($strCuesheet))
		FileClose($objCuesheet)
	EndIf
EndFunc
