; Version 1.0

Func fStartFromCuesheet()
	Local $strFile, $objFile, $strCuesheet
	Local $strPath
	Local $strWave, $strArtist, $strAlbum, $strDate, $strGenre, $strComment, $strFreedbId
	Local $strParameters
	Local $strWaveFile, $strWavePath

	$strFile = $CmdLine[1]
	$objFile = FileOpen($strFile, 0)
	If $objFile = -1 Then
		MsgBox(0, "REACT", "Unable to open cuesheet '" & $strFile & "'")
		Exit
	EndIf
	$strCuesheet = FileRead($objFile)

	$strPath = fGetDirName($strFile)
	$strWave = fExtractMetaItem($strCuesheet, 'FILE "(.*)\..*" (WAVE|MP3|AIFF)') & ".wav"
	$strArtist = fExtractMetaItem($strCuesheet, "PERFORMER (.*)\r")
	$strAlbum = fExtractMetaItem($strCuesheet, "TITLE (.*)\r")
	$strDate = fExtractMetaItem($strCuesheet, "REM DATE (.*)\r")
	$strGenre = fExtractMetaItem($strCuesheet, "REM GENRE(.*)\r")
	$strComment = fExtractMetaItem($strCuesheet, "REM COMMENT (.*)\r")
	$strFreedbId = fExtractMetaItem($strCuesheet, "REM DISCID (.*)\r")

	FileClose($objFile)
	
	; Check that the WAVE exists
	$strWavePath = $strPath & '\' & $strWave
	If FileExists($strWavePath) = false Then
		MsgBox(0, "REACT", "Unable to locate WAVE file '" & $strWavePath & "'")
		Exit		
	EndIf

	$strParameters = 'REACT "' & $strWave & '" "' & $strWavePath & '" "' & $strWavePath & '" "' & $strArtist & '" "' & $strAlbum & '" XXX 2 2 ' & $strDate & ' "' & $strGenre & '" "' & $strComment & '" "' & $strFreedbId & '" XXX XXX'

	ShellExecute(@ScriptFullPath, $strParameters, "", "", @SW_HIDE)
EndFunc

Func fExtractMetaItem($strContent, $strRegExp)
	Local $arrMatch
	$arrMatch = StringRegExp($strContent, $strRegExp, 1)
	If @error == 0 Then
		Return fDeQuote($arrMatch[0])
	EndIf
EndFunc

Func fDeQuote($strValue)
	Local $arrMatch
	$arrMatch = StringRegExp($strValue, '"(.*)"', 1)
	If @error == 0 Then
		Return $arrMatch[0]
	Else
		Return $strValue
	EndIf
EndFunc

Func fGetDirName($strFullPath)
	Local $arrMatch
	$arrMatch = StringRegExp($strFullPath, "(.*)\\.*", 1)
	If @error == 0 Then
		Return $arrMatch[0]
	EndIf
EndFunc
